//
// nono
// Copyright (C) 2024 nono project
// Licensed under nono-license.txt
//

//
// メインバス (virt68k)
//

#pragma once

#include "mainbus.h"

class Virt68kMainbus : public Mainbus24Device
{
	using inherited = Mainbus24Device;
 public:
	Virt68kMainbus();
	~Virt68kMainbus() override;

	bool InitMainbus() override;

 private:
	// ブートページを切り替える。
	void SwitchBootPage(bool isrom) override;

	std::unique_ptr<IODevice> pBusErr {};
	std::unique_ptr<IODevice> pInterrupt {};
	std::unique_ptr<IODevice> pMainRAM {};
	std::unique_ptr<IODevice> pV68kIO {};
};
